#include "cvsh_createVD.hpp"

#include "../cli/cli_dev.hpp"
#include "../cli/cli_wrap.hpp"

#include "../img/img_wrap.hpp"

//#include "vd/vd_net.hpp"
#include "../vd/vd_file.hpp"
#include "../vd/vd_win.hpp"


#include <assert.h>

#include <iostream>
#include <vector>



  
//////////////////////////////////////////////////////
// create video destination
namespace{

vd_base* createVD(
  const cli_dev& dst, 
  const img_fmt& fmt)
{
  vd_base* pvd=0;

  switch (dst.type()){
  case cli_dev::Win:
  {
    pvd= new vd_win(fmt, dst.name());
    break;
  }
  case cli_dev::File:{
    pvd=vd_file::create(dst.name(), fmt);
    break;
  }case cli_dev::Net:
    // host, port
    // pvd= new vd_net(fmt, dst.par(0);
    assert(0);
    break;
  default:
    //should not happen...
    assert(0);
    break;
  }
  return pvd;
}

} // end unnamed namespace

  
//////////////////////////////////////////////////////
// the exported functions

void cvsh_createVD(
  std::ostream& os,
  const std::vector<cli_dev>& vec_dst,
  const img_fmt& fmt,
  std::vector<boost::shared_ptr<vd_base> >& vecSpVd)
{
  for (unsigned i=0; i<vec_dst.size(); i++){
    vd_base* pNew=createVD(vec_dst[i], fmt);
    boost::shared_ptr<vd_base> spNew(pNew);
    assert(spNew.use_count()==1);
    vecSpVd.push_back(spNew);
    assert(spNew.use_count()==2);
  }

  os <<"  Created " <<vecSpVd.size() <<" vd-s: "
     <<fmt.width() <<" x " 
     <<fmt.height() <<" x " 
     <<fmt.szPixel() <<" (" 
     <<fmt.szLine() <<")\n";
}


