#include "alg_canny251_gradijent.hpp"

#include "../../img/img_wrap.hpp"

#include <math.h>


int gradientDouble(
  int margin,
  const img_wrap& imgSmooth, 
  img_wrap& imgGrad, 
  img_wrap& imgPhi)
  {
    int width=imgGrad.fmt().width();
    int height=imgGrad.fmt().height();
    ++margin;

    double* psrc = (double*)imgSmooth.bits();
    double* pgrad = (double*)imgGrad.bits();
    double* pphi = (double*)imgPhi.bits();

    //prolaz po svim pikselima te racunanje gradijenta
    //i kuta gradijenta za svaki piksel
    for (int i=margin; i<height-margin; ++i) 
      {
        for (int j=margin; j<width-margin; ++j) 
          {
            int k=i*width+j;
            double gx=psrc[k+1] - psrc[k-1];
            double gy=psrc[(i+1)*width+j] - psrc[(i-1)*width+j];

            pgrad[k]=sqrt(gx*gx+gy*gy);
            pphi[k]=atan2(gy, gx);
          }
      }

    return margin;
  }
