
#include "img_access_util.hpp"
#include "img_access_dispatch.hpp"
#include "img_access_pix.hpp"

#include "../img_wrap.hpp"

///////////////////////////////////////////////
// class for static dispatching
// * member template functions defined in-class
//   because of the buggy MS compiler
// * dummies needed because the buggy MSVC supports 
//   only implicit resolution of template functions
// * typedefs are used by dispatch template functions

class MaxScalarWorker{
public:
  typedef const img_wrap& Param1;
public:
  MaxScalarWorker(){}
  template <class PixelSrc>
  inline int operator() (
    const img_wrap& , const PixelSrc&)
  {
    return PixelSrc::MaxScalar;
  }
};

int img_access_util::maxScalar(const img_wrap& src){
  MaxScalarWorker w;
  return img_access_dispatch1(src,w);
}

