#ifndef vs_file_avi_hpp
#define vs_file_avi_hpp

/******************************************************
*
*   vs_file_avi.hpp by Sinisa Segvic
*
** describes acquisition of a sequence of image
** frames with possibly variable format from an AVI file
*
** vs_file_avi IS_A vs_file IS_A vs_base
*
*******************************************************/

#include "../../vs/vs_file.hpp"


class vs_file_avi_imp;

class vs_file_avi: 
  public vs_file
{
public:
  vs_file_avi(const CtorArg& arg);
  virtual ~vs_file_avi();

//vs_file_util attributes
public:
  static char const* s_name(){ return "avi"; }
  virtual char const* name(){ return s_name(); }

//attributes
public:
  virtual int count();
  virtual double fps();
  virtual char const* asciiDescriptor();
public:
  virtual const img_fmt& fmt();
public:
  virtual int msDayUtc();
private:
  virtual void getFrameSimple(img_wrap&);

//vs_file_avi data
private:
  vs_file_avi_imp* pimp;
};

#endif
