#ifndef vs_file_wmv_hpp
#define vs_file_wmv_hpp

/******************************************************
*
*   vs_file_wmv.hpp by Sinisa Segvic
*
** describes acquisition of a sequence of image
** frames with possibly variable format from an wmv file
*
** vs_file_wmv IS_A vs_file IS_A vs_base
*
*******************************************************/

#include "../../vs/vs_file.hpp"


class vs_file_wmv_imp;

class vs_file_wmv: 
  public vs_file
{
public:
  vs_file_wmv(const CtorArg& arg);
  virtual ~vs_file_wmv();

//vs_file_util attributes
public:
  static char const* s_name(){ return "wmv"; }
  virtual char const* name(){ return s_name(); }

//attributes
public:
  virtual int count();
  virtual double fps();
  virtual char const* asciiDescriptor();
  virtual const img_fmt& fmt();
  virtual int msDayUtc();
private:
  virtual void getFrameSimple(img_wrap&);

private:
  vs_file_wmv_imp* pimp;
};

#endif
