#include "util_fs.hpp"

#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <stdexcept>


char util_fs::dirDelimiter(){
  return '\\';
}
const char* util_fs::defaultTempDir(){
  return "C:\temp";
}


bool util_fs::checkFileWrite(char const* p){
  return _access(p, 2)==0;
}
bool util_fs::checkFileRead(char const* p){
  return _access(p, 0)==0;
}


bool util_fs::readDir(char const* path,
  std::vector<std::string>& entries)
{
  //std::cerr <<"Beware, util_fs::readDir not tested\n";

  std::string strPath(path);
  if (strPath[strPath.size()-1]!='/'){
    strPath=strPath+"/";
  }

  std::string wildcard=strPath+"*.*";
  struct _finddata_t finddata;
  intptr_t find_handle=_findfirst(wildcard.c_str(), &finddata);
  if (find_handle == -1) 
    return false;

  while (1){
    if (finddata.name[0] !='.') {
      entries.push_back(strPath+finddata.name);
      // std::cerr <<entries.back() <<"\n";
    }

    int rv=_findnext(find_handle, &finddata);
    if (rv != 0) break;
  }
  std::sort(entries.begin(), entries.end());

  _findclose(find_handle);
  return true;
}


bool util_fs::isDir(char const* path){
  //throw std::runtime_error("util_fs::isDir not implemented");
  struct stat buf;
  stat(path, &buf);
  return (buf.st_mode & _S_IFDIR)!=0;
}



