#include "vd_file.hpp"
#include "vd_file_single.hpp"

#include "../util/util_string.hpp"

// see Lakos #9.3.3 @681
vd_file::~vd_file(){}


////////////////////////
// vd_file static methods

vd_file* vd_file::create(
  const char* name, 
  const img_fmt& fmt)
{
  vd_file *pvdf=0;

  char const* ext=util_string::getFileExtension(name);
  util::Registry& reg=util::Registry::instance();
  util::Registry::Iterator it=reg.find<vd_file>(ext);

  if (it != reg.end<vd_file>()){
    pvdf=reg.create<vd_file>(it, vd_file::CtorArg(name, fmt));
  } else{
    pvdf=new vd_file_single(name, fmt);
  }

  return pvdf;
}

