#ifndef vd_file_hpp
#define vd_file_hpp

/******************************************************
*
*  vd_file by Sinisa Segvic
*
** storing a sequence of image frames 
** with common format to a file
*
** vd_file IS_A vd_base
*
*******************************************************/

#include "vd_base.hpp"
#include "../util/util_registry.hpp"


class vd_file: 
  public vd_base
{
  
//construction
protected:
  vd_file(const img_fmt& f): vd_base(f) {}
public:
  virtual ~vd_file();

//vd_base attributes
public:
  virtual bool isFile(){ return true;}
  virtual bool isWin(){ return false;}
  virtual bool canReformat(){ return false;}

public:
  virtual char const* name() =0;
  
//operations
public:
  virtual void operator()(
      const img_wrap& img, int time=0, int frame=-1)=0;

//vd_file construction
public:
  // concrete classes ctor argument
  struct CtorArg{
  public:
    char const* name;
    const img_fmt& fmt;
  public:
    CtorArg(char const* n, const img_fmt& f):
      name(n), fmt(f)
    {}
  };
  //concrete classes factory
  static vd_file* create(
    const char* name, 
    const img_fmt& fmt);
};


#endif
