#include <fstream>

#include "vd_file_srs.hpp"

#include "../img/img_wrap.hpp"
#include "../img/io/img_io_save_ras.hpp"

/////////////////////////////////////
// static registry creator object

namespace{
  util::RegistryCreator<vd_file,vd_file_srs> creator;
}

///////////////////////////////////////////
// vd_file_srs private implementation data

struct vd_file_srs_imp{
  vd_file_srs_imp(char const* filename);
  vd_file_srs_imp();//stdout assumed
  img_io_save_ras ds;
private:
  vd_file_srs_imp(const vd_file_srs_imp&);
  const vd_file_srs_imp& operator=(const vd_file_srs_imp& );
};

vd_file_srs_imp::vd_file_srs_imp(char const* filename):
  ds(filename)
{ }

vd_file_srs_imp::vd_file_srs_imp():
  ds()
{ }


///////////////////////////////////////////
// vd_file_srs member definitions
vd_file_srs::vd_file_srs(
  const CtorArg& arg)
:
  vd_file(arg.fmt),
  pimp(new vd_file_srs_imp(arg.name))
{
}

vd_file_srs::vd_file_srs(
  const img_fmt& fmt)
:
  vd_file(fmt),
  pimp(new vd_file_srs_imp())
{
}


vd_file_srs::~vd_file_srs(){
  delete pimp;
}

void vd_file_srs::operator()(
  const img_wrap& img, 
  int, int)
{
  checkFmt(img.fmt());
  pimp->ds(img); 
}


