#ifndef vs_file_txt_hpp
#define vs_file_txt_hpp

/******************************************************
*
*   vs_file_txt.hpp by Sinisa Segvic
*
** describes acquisition from multiple files
** with different formats through 
** a vs_base interface, 
** using a textual command file
*
** each line in the command file specifies
** a single vs spec (see vs_file_many.hpp)
*
** vs_file_txt IS_A vs_file_many IS_A vs_file IS_A vs_base
*
*******************************************************/

#include "vs_file.hpp"
#include "vs_file_many.hpp"

#include<string>

class vs_file_txt: 
  public vs_file_many
{
public:
  vs_file_txt(const CtorArg& arg);
  virtual ~vs_file_txt();

//vs_file_util attributes
public:
  static char const* s_name(){ return "txt"; }
  virtual char const* name(){ return s_name(); }

//vs_base methods (most inherited from fs_file_many)
public:
  virtual char const* asciiDescriptor();
  // virtual int count();
  // virtual const img_fmt& fmt();
  // virtual int msDayUtc();
  // virtual void getFrameSimple(img_wrap&);

// vs_file_txt data
private:
  std::string strTxtFile_;
};


#endif


