#include "vs_file.hpp"

#include "vs_file_dir.hpp"
#include "vs_file_single.hpp"

#include "../util/util_registry.hpp"

#include "../util/util_string.hpp"
#include "../util/util_fs.hpp"

#include <iostream>
#include <stdexcept>

#include <assert.h>

/******************************************************
*
*        vs_file_util.CPP  by Sinisa Segvic
**  utility functions for the whole vs_file hierarchy
**
**************************************************/
#include "vs_file_util.hpp"


vs_file* vs_file_util::create(const char* name){
  vs_file *pvsf=0;

  size_t len=strlen(name);
  if (name[len-1]==util_fs::dirDelimiter()){
    pvsf=new vs_file_dir(name);
  } else{
    char const* ext=util_string::getFileExtension(name);
    if (!ext){
      throw std::runtime_error("vs_file_util::create - got file without extension");
    }

    util::Registry& reg=util::Registry::instance();
    util::Registry::Iterator it=reg.find<vs_file>(ext);
    if (it != reg.end<vs_file>()){
      pvsf=reg.create<vs_file>(it, vs_file::CtorArg(name));
    } else{
      pvsf=new vs_file_single(name);
    }
  }
  return pvsf;
}

